;; 
;    include \masm32\include\masm32rt.inc

.686P
.MMX
.XMM
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED
OPTION LJMP
OPTION CASEMAP:NONE


;
; inc files
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc


;
; lib files
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\masm32.lib

INCLUDE \Masm32\MACROS\macros.asm


.DATA
;
ALIGN 16
_3D_Signs_Mask_3_2_1_0_	DWORD 080000000h,080000000h,080000000h,080000000h

_3D_Values_1_1_1_1_		DWORD 03F800000h,03F800000h,03F800000h,03F800000h
_3D_Values_m1_1_1_m1_	DWORD 0BF800000h,03F800000h,03F800000h,0BF800000h

_Results_				DWORD ?,?,?,?


.CODE
ALIGN 16
;
GenerateMask_01 PROC

		movdqa XMM1,XMM5								;; XMM1 = Z2+profondeur,Z2+profondeur,Z1+profondeur,Z1+profondeur
		cmpltps XMM1,XMM6								;; comparer Z2+profondeur,Z2+profondeur,Z1+profondeur,Z1+profondeur  0,0,0,0
		pslld XMM1,31									;; conserver le masque des signes obtenus dans XMM1
;		...
		pxor XMM0,XMM1									;; inverser les signes de X et Y en fonction du masque en XMM1

  ret

GenerateMask_01 ENDP
; 


ALIGN 16
;
GenerateMask_02 PROC

		movdqa XMM1,XMM5								;; XMM1 = Z2+profondeur,Z2+profondeur,Z1+profondeur,Z1+profondeur
		psrad XMM1,31									;; conserver les masques des valeurs signes
		pslld XMM1,31									;; conserver le masque des signes obtenus dans XMM1
;		...
		pxor XMM0,XMM1									;; inverser les signes de X et Y en fonction du masque en XMM1

    ret

GenerateMask_02 ENDP
; 


ALIGN 16
;
UseMaskValue PROC

		movdqa XMM1,XMM5								;; XMM1 = Z2+profondeur,Z2+profondeur,Z1+profondeur,Z1+profondeur
		pand XMM1,OWORD PTR [_3D_Signs_Mask_3_2_1_0_]		;; conserver les signes ngatifs
;		...
		pxor XMM0,XMM1									;; inverser les signes de X et Y en fonction du masque en XMM1


	ret
UseMaskValue ENDP


; 



start:
; 

movdqa XMM0,_3D_Values_1_1_1_1_
movdqa XMM5,_3D_Values_m1_1_1_m1_
pxor XMM6,XMM6

    mov ebx, 1000000000
    invoke GetTickCount
    push eax
    .WHILE ebx
      call GenerateMask_01
      dec ebx
    .ENDW
    invoke GetTickCount
    pop edx
    sub eax, edx
    print ustr$(eax),13,10

movdqa _Results_,XMM0
print chr$(13,10)
mov eax,_Results_
print ustr$(eax)
mov eax,_Results_+4
print ustr$(eax)
mov eax,_Results_+8
print ustr$(eax)
mov eax,_Results_+12
print ustr$(eax)
print chr$(13,10)

    mov ebx, 1000000000
    invoke GetTickCount
    push eax
    .WHILE ebx
      call GenerateMask_02
      dec ebx
    .ENDW
    invoke GetTickCount
    pop edx
    sub eax, edx
    print ustr$(eax),13,10

movdqa _Results_,XMM0
print chr$(13,10)
mov eax,_Results_
print ustr$(eax)
mov eax,_Results_+4
print ustr$(eax)
mov eax,_Results_+8
print ustr$(eax)
mov eax,_Results_+12
print ustr$(eax)
print chr$(13,10)

    mov ebx, 1000000000
    invoke GetTickCount
    push eax
    .WHILE ebx
      call UseMaskValue
      dec ebx
    .ENDW
    invoke GetTickCount
    pop edx
    sub eax, edx
    print ustr$(eax),13,10

movdqa _Results_,XMM0
print chr$(13,10)
mov eax,_Results_
print ustr$(eax)
mov eax,_Results_+4
print ustr$(eax)
mov eax,_Results_+8
print ustr$(eax)
mov eax,_Results_+12
print ustr$(eax)
print chr$(13,10)


;    inkey "Press any key to exit..."
		invoke Sleep,1000
		mov eax,input(13,10,13,10," Press ENTER to quit...")

;    exit
		Invoke ExitProcess,0

; 
end start
